// Auto-generated. Do not edit!

// (in-package clearpath_mission_manager_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let clearpath_navigation_msgs = _finder('clearpath_navigation_msgs');

//-----------------------------------------------------------

class StorageState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.missions = null;
      this.waypoints = null;
      this.tasks = null;
    }
    else {
      if (initObj.hasOwnProperty('missions')) {
        this.missions = initObj.missions
      }
      else {
        this.missions = [];
      }
      if (initObj.hasOwnProperty('waypoints')) {
        this.waypoints = initObj.waypoints
      }
      else {
        this.waypoints = [];
      }
      if (initObj.hasOwnProperty('tasks')) {
        this.tasks = initObj.tasks
      }
      else {
        this.tasks = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type StorageState
    // Serialize message field [missions]
    // Serialize the length for message field [missions]
    bufferOffset = _serializer.uint32(obj.missions.length, buffer, bufferOffset);
    obj.missions.forEach((val) => {
      bufferOffset = clearpath_navigation_msgs.msg.Mission.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [waypoints]
    // Serialize the length for message field [waypoints]
    bufferOffset = _serializer.uint32(obj.waypoints.length, buffer, bufferOffset);
    obj.waypoints.forEach((val) => {
      bufferOffset = clearpath_navigation_msgs.msg.Waypoint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [tasks]
    // Serialize the length for message field [tasks]
    bufferOffset = _serializer.uint32(obj.tasks.length, buffer, bufferOffset);
    obj.tasks.forEach((val) => {
      bufferOffset = clearpath_navigation_msgs.msg.Task.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type StorageState
    let len;
    let data = new StorageState(null);
    // Deserialize message field [missions]
    // Deserialize array length for message field [missions]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.missions = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.missions[i] = clearpath_navigation_msgs.msg.Mission.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [waypoints]
    // Deserialize array length for message field [waypoints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.waypoints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.waypoints[i] = clearpath_navigation_msgs.msg.Waypoint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [tasks]
    // Deserialize array length for message field [tasks]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tasks = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tasks[i] = clearpath_navigation_msgs.msg.Task.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.missions.forEach((val) => {
      length += clearpath_navigation_msgs.msg.Mission.getMessageSize(val);
    });
    object.waypoints.forEach((val) => {
      length += clearpath_navigation_msgs.msg.Waypoint.getMessageSize(val);
    });
    object.tasks.forEach((val) => {
      length += clearpath_navigation_msgs.msg.Task.getMessageSize(val);
    });
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_mission_manager_msgs/StorageState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2aec6b1dea30ea07c12bde29633c1a25';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The entire contents of the Mission database
    # Note that all of the following cases are valid:
    # - a Task can be referenced in multiple Waypoints
    # - a Waypoint can be referenced in multiple Missions
    # - a Waypoint can be orphaned (i.e. not included in any Missions)
    # - a Task can be orphaned (i.e. not included in any Waypoints)
    
    # All missions defined in the database
    clearpath_navigation_msgs/Mission[] missions
    
    # All waypoints defined in the database
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # All tasks defined in the database
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Mission
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    # The human-readable name of this mission
    string name
    
    # A UUID string used to uniquely identify this mission
    string uuid
    
    # The ordered list of Waypoints that make up the mission
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # An array of Tasks to execute on Mission start
    clearpath_navigation_msgs/Task[] on_start
    
    # An array of Tasks to execute on Mission stop
    # These Tasks will execute regardless of mission success or failure
    clearpath_navigation_msgs/Task[] on_stop
    
    # Configuration parameters for the mission
    # Additional details TBD
    string onav_config
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new StorageState(null);
    if (msg.missions !== undefined) {
      resolved.missions = new Array(msg.missions.length);
      for (let i = 0; i < resolved.missions.length; ++i) {
        resolved.missions[i] = clearpath_navigation_msgs.msg.Mission.Resolve(msg.missions[i]);
      }
    }
    else {
      resolved.missions = []
    }

    if (msg.waypoints !== undefined) {
      resolved.waypoints = new Array(msg.waypoints.length);
      for (let i = 0; i < resolved.waypoints.length; ++i) {
        resolved.waypoints[i] = clearpath_navigation_msgs.msg.Waypoint.Resolve(msg.waypoints[i]);
      }
    }
    else {
      resolved.waypoints = []
    }

    if (msg.tasks !== undefined) {
      resolved.tasks = new Array(msg.tasks.length);
      for (let i = 0; i < resolved.tasks.length; ++i) {
        resolved.tasks[i] = clearpath_navigation_msgs.msg.Task.Resolve(msg.tasks[i]);
      }
    }
    else {
      resolved.tasks = []
    }

    return resolved;
    }
};

module.exports = StorageState;
