// Auto-generated. Do not edit!

// (in-package clearpath_mission_manager_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let clearpath_navigation_msgs = _finder('clearpath_navigation_msgs');

//-----------------------------------------------------------

class GetMissionRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.uuid = null;
    }
    else {
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetMissionRequest
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetMissionRequest
    let len;
    let data = new GetMissionRequest(null);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.uuid);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/GetMissionRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '18ad0215778d252d8f14959901273e8d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The UUID of the Mission we want to retrieve
    string uuid
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetMissionRequest(null);
    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    return resolved;
    }
};

class GetMissionResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.mission = null;
    }
    else {
      if (initObj.hasOwnProperty('mission')) {
        this.mission = initObj.mission
      }
      else {
        this.mission = new clearpath_navigation_msgs.msg.Mission();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetMissionResponse
    // Serialize message field [mission]
    bufferOffset = clearpath_navigation_msgs.msg.Mission.serialize(obj.mission, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetMissionResponse
    let len;
    let data = new GetMissionResponse(null);
    // Deserialize message field [mission]
    data.mission = clearpath_navigation_msgs.msg.Mission.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += clearpath_navigation_msgs.msg.Mission.getMessageSize(object.mission);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/GetMissionResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '12103094a50ee841f126ea9995ad7bdc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The Mission with the given ID, or null if no Mission with that ID exists
    clearpath_navigation_msgs/Mission mission
    
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Mission
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    # The human-readable name of this mission
    string name
    
    # A UUID string used to uniquely identify this mission
    string uuid
    
    # The ordered list of Waypoints that make up the mission
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # An array of Tasks to execute on Mission start
    clearpath_navigation_msgs/Task[] on_start
    
    # An array of Tasks to execute on Mission stop
    # These Tasks will execute regardless of mission success or failure
    clearpath_navigation_msgs/Task[] on_stop
    
    # Configuration parameters for the mission
    # Additional details TBD
    string onav_config
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetMissionResponse(null);
    if (msg.mission !== undefined) {
      resolved.mission = clearpath_navigation_msgs.msg.Mission.Resolve(msg.mission)
    }
    else {
      resolved.mission = new clearpath_navigation_msgs.msg.Mission()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetMissionRequest,
  Response: GetMissionResponse,
  md5sum() { return '7196ed9731d80a113d2ce425c7a0b190'; },
  datatype() { return 'clearpath_mission_manager_msgs/GetMission'; }
};
