// Auto-generated. Do not edit!

// (in-package clearpath_mission_manager_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let clearpath_navigation_msgs = _finder('clearpath_navigation_msgs');

//-----------------------------------------------------------

class GetWaypointRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.uuid = null;
    }
    else {
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetWaypointRequest
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetWaypointRequest
    let len;
    let data = new GetWaypointRequest(null);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.uuid);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/GetWaypointRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '18ad0215778d252d8f14959901273e8d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The UUID of the Waypoint we want to retrieve
    string uuid
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetWaypointRequest(null);
    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    return resolved;
    }
};

class GetWaypointResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.waypoint = null;
    }
    else {
      if (initObj.hasOwnProperty('waypoint')) {
        this.waypoint = initObj.waypoint
      }
      else {
        this.waypoint = new clearpath_navigation_msgs.msg.Waypoint();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetWaypointResponse
    // Serialize message field [waypoint]
    bufferOffset = clearpath_navigation_msgs.msg.Waypoint.serialize(obj.waypoint, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetWaypointResponse
    let len;
    let data = new GetWaypointResponse(null);
    // Deserialize message field [waypoint]
    data.waypoint = clearpath_navigation_msgs.msg.Waypoint.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += clearpath_navigation_msgs.msg.Waypoint.getMessageSize(object.waypoint);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/GetWaypointResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd02d472a6293b4d48069e0df4807c97a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The Waypoint with the given ID, or null if no Waypoint with that ID exists
    clearpath_navigation_msgs/Waypoint waypoint
    
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetWaypointResponse(null);
    if (msg.waypoint !== undefined) {
      resolved.waypoint = clearpath_navigation_msgs.msg.Waypoint.Resolve(msg.waypoint)
    }
    else {
      resolved.waypoint = new clearpath_navigation_msgs.msg.Waypoint()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetWaypointRequest,
  Response: GetWaypointResponse,
  md5sum() { return '906c00b2ef8e7d6b5f0776b8997f3bf7'; },
  datatype() { return 'clearpath_mission_manager_msgs/GetWaypoint'; }
};
