// Auto-generated. Do not edit!

// (in-package clearpath_mission_manager_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let StorageState = require('../msg/StorageState.js');

//-----------------------------------------------------------

class ImportDataRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataRequest
    // Serialize message field [data]
    bufferOffset = _serializer.string(obj.data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataRequest
    let len;
    let data = new ImportDataRequest(null);
    // Deserialize message field [data]
    data.data = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.data);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/ImportDataRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '992ce8a1687cec8c8bd883ec73ca41d1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A JSON string representing the database contents.
    # This is the same as the data output by the ExportData service, and is intended
    # to be used to restore the database to a previous state
    string data
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataRequest(null);
    if (msg.data !== undefined) {
      resolved.data = msg.data;
    }
    else {
      resolved.data = ''
    }

    return resolved;
    }
};

class ImportDataResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.state = null;
    }
    else {
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = new StorageState();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImportDataResponse
    // Serialize message field [state]
    bufferOffset = StorageState.serialize(obj.state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImportDataResponse
    let len;
    let data = new ImportDataResponse(null);
    // Deserialize message field [state]
    data.state = StorageState.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += StorageState.getMessageSize(object.state);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'clearpath_mission_manager_msgs/ImportDataResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '558727109043706c539b7a6e4690cd41';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The state of the database after importing the data
    clearpath_mission_manager_msgs/StorageState state
    
    
    ================================================================================
    MSG: clearpath_mission_manager_msgs/StorageState
    # The entire contents of the Mission database
    # Note that all of the following cases are valid:
    # - a Task can be referenced in multiple Waypoints
    # - a Waypoint can be referenced in multiple Missions
    # - a Waypoint can be orphaned (i.e. not included in any Missions)
    # - a Task can be orphaned (i.e. not included in any Waypoints)
    
    # All missions defined in the database
    clearpath_navigation_msgs/Mission[] missions
    
    # All waypoints defined in the database
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # All tasks defined in the database
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Mission
    # Message definition for an OutdoorNav mission
    
    std_msgs/Header header
    
    # The human-readable name of this mission
    string name
    
    # A UUID string used to uniquely identify this mission
    string uuid
    
    # The ordered list of Waypoints that make up the mission
    clearpath_navigation_msgs/Waypoint[] waypoints
    
    # An array of Tasks to execute on Mission start
    clearpath_navigation_msgs/Task[] on_start
    
    # An array of Tasks to execute on Mission stop
    # These Tasks will execute regardless of mission success or failure
    clearpath_navigation_msgs/Task[] on_stop
    
    # Configuration parameters for the mission
    # Additional details TBD
    string onav_config
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Waypoint
    # A single Waypoint along a Mission
    
    # A UUID string to uniquely identify this Waypoint
    string uuid
    
    # The human-readable name of this Waypoint
    string name
    
    # The latitude (in degrees) of this Waypoint
    float64 latitude
    
    # The longitude (in degrees) of this Waypoint
    float64 longitude
    
    # The compass heading (in degrees) of this Waypoint
    float64 heading
    
    # A radius in meters indicating the acceptable radius from the target location
    # Posititon tolerance is disabled if this value is negative
    float64 position_tolerance
    
    # A tolerance in degrees indicating the acceptable deviation from the heading
    # Heading tolerance is disabled if this value is negative
    float64 yaw_tolerance
    
    # The ordered set of Tasks to execute once the goal position & orientation are reached
    clearpath_navigation_msgs/Task[] tasks
    
    ================================================================================
    MSG: clearpath_navigation_msgs/Task
    # A single task that can be executed at a Waypoint
    
    # The human-readable name of this task
    string name
    
    # A UUID string to uniquely identify this Task
    string uuid
    
    # The ROS action that this task executes
    string action_server_name
    
    # The version of this task
    string version
    
    # Numerical/boolean data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    float64[] floats
    
    # String data to be passed to the action_server_name
    # The exact meaning of these values is dependent on the underlying service
    string[] strings
    
    # Boolean value which determines whether a mission using this task can continue
    # if this task fails to execute
    bool allow_failure
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImportDataResponse(null);
    if (msg.state !== undefined) {
      resolved.state = StorageState.Resolve(msg.state)
    }
    else {
      resolved.state = new StorageState()
    }

    return resolved;
    }
};

module.exports = {
  Request: ImportDataRequest,
  Response: ImportDataResponse,
  md5sum() { return '6a3e0bd7ca1e99082e3e8ee22260747c'; },
  datatype() { return 'clearpath_mission_manager_msgs/ImportData'; }
};
